/**
 * SPDX-FileCopyrightText: © 2021 Liferay, Inc. <https://liferay.com>
 * SPDX-License-Identifier: BSD-3-Clause
 */

'use strict';

/**
 * Holds value error messages.
 * @const
 */

Liferay.Loader.define("frontend-js-spa-web$senna@2.8.0/lib/errors/errors", ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    var errors = function errors() {
      _classCallCheck(this, errors);
    };

    /**
     * Invalid status error message.
     * @type {string}
     * @static
     */

    errors.INVALID_STATUS = 'Invalid status code';

    /**
     * Request error message.
     * @type {string}
     * @static
     */
    errors.REQUEST_ERROR = 'Request error';

    /**
     * Request timeout error message.
     * @type {string}
     * @static
     */
    errors.REQUEST_TIMEOUT = 'Request timeout';

    /**
     * Request is blocked by CORS issue message.
     * @type {string}
     * @static
     */
    errors.REQUEST_PREMATURE_TERMINATION = 'Request terminated prematurely';

    exports.default = errors;
  }
});
//# sourceMappingURL=errors.js.map