Liferay.Loader.define("style-book-web@1.0.34/js/style-book-editor/FrontendTokenSet", ['module', 'exports', 'require', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './Collapse', './StyleBookContext', './constants/frontendTokenTypes', './frontend_tokens/BooleanFrontendToken', './frontend_tokens/ColorFrontendToken', './frontend_tokens/SelectFrontendToken', './frontend_tokens/TextFrontendToken'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = FrontendTokenSet;

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _Collapse = _interopRequireDefault(require("./Collapse"));

    var _StyleBookContext = require("./StyleBookContext");

    var _frontendTokenTypes = require("./constants/frontendTokenTypes");

    var _BooleanFrontendToken = _interopRequireDefault(require("./frontend_tokens/BooleanFrontendToken"));

    var _ColorFrontendToken = _interopRequireDefault(require("./frontend_tokens/ColorFrontendToken"));

    var _SelectFrontendToken = _interopRequireDefault(require("./frontend_tokens/SelectFrontendToken"));

    var _TextFrontendToken = _interopRequireDefault(require("./frontend_tokens/TextFrontendToken"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function FrontendTokenSet(_ref) {
      var frontendTokens = _ref.frontendTokens,
          label = _ref.label;

      var _useContext = (0, _react.useContext)(_StyleBookContext.StyleBookContext),
          _useContext$frontendT = _useContext.frontendTokensValues,
          frontendTokensValues = _useContext$frontendT === void 0 ? {} : _useContext$frontendT,
          setFrontendTokensValues = _useContext.setFrontendTokensValues;

      var updateFrontendTokensValues = function updateFrontendTokensValues(frontendToken, value) {
        var _frontendToken$mappin = frontendToken.mappings,
            mappings = _frontendToken$mappin === void 0 ? [] : _frontendToken$mappin,
            name = frontendToken.name;
        var cssVariableMapping = mappings.find(function (mapping) {
          return mapping.type === 'cssVariable';
        });

        if (value) {
          setFrontendTokensValues(_objectSpread(_objectSpread({}, frontendTokensValues), {}, _defineProperty({}, name, {
            cssVariableMapping: cssVariableMapping.value,
            value: value
          })));
        }
      };

      return (/*#__PURE__*/_react.default.createElement(_Collapse.default, {
          label: label
        }, frontendTokens.map(function (frontendToken) {
          var _frontendTokensValues;

          var FrontendTokenComponent = getFrontendTokenComponent(frontendToken);
          return (/*#__PURE__*/_react.default.createElement(FrontendTokenComponent, {
              frontendToken: frontendToken,
              key: frontendToken.name,
              onValueSelect: function onValueSelect(value) {
                return updateFrontendTokensValues(frontendToken, value);
              },
              value: ((_frontendTokensValues = frontendTokensValues[frontendToken.name]) === null || _frontendTokensValues === void 0 ? void 0 : _frontendTokensValues.value) || frontendToken.defaultValue
            })
          );
        }))
      );
    }

    function getFrontendTokenComponent(frontendToken) {
      if (frontendToken.editorType === 'ColorPicker') {
        return _ColorFrontendToken.default;
      }

      if (frontendToken.validValues) {
        return _SelectFrontendToken.default;
      }

      if (frontendToken.type === _frontendTokenTypes.FRONTEND_TOKEN_TYPES.boolean) {
        return _BooleanFrontendToken.default;
      }

      return _TextFrontendToken.default;
    }
    //# sourceMappingURL=FrontendTokenSet.js.map
  }
});
//# sourceMappingURL=FrontendTokenSet.js.map